#!/usr/bin/perl -w

my $debug=0;

use strict;

my %register;
my %files;
my ($ifn,$fn,$pri);
my ($count,$del);

foreach (@ARGV) {
	if ($_ eq '-d') { $debug=1; next; }
	print "Reading $_ ...\n" if $debug;
	open(F,"<$_") || die $!;
	$fn=""; $ifn=$_;
	while (<F>) {
		chomp;
		if (/^----\s*(\S*)\s*(\S*)\s*(\S*)/) {
			$files{$1}='' if not defined $files{$1};
			$fn=$1; $pri=$2; $del=$3; $del=~s/(.)/\\$1/g;
			if ($pri ne "1" && defined $register{"$fn $pri"}) {
				print "**\n** Priority dup: out=$fn in=$ifn pri=$pri\n**\n";
				exit 1;
			}
			$register{"$fn $pri"}="x";
			$files{$fn}.=$pri." 00000 #### $ifn $pri\n" if $debug;
			print "---> $fn $pri\n" if $debug;
			$count=1; next;
		};
		next if $fn eq '';
		if (/^$del(.*)/) {
			$files{$fn}.=$pri.sprintf(" %05d ",$count).$1."\n";
			$count++; next;
		}
	}
	close F;
}

foreach (sort keys %files) {
	print "Creating $_ ...\n";
	open(F,"| sort | cut -f3- -d' ' > $_") || die $!;
	print F $files{$_};
	close(F);
}
